window.Gleam.initSearch([{"doc":"acrostic","title":"acrostic","content":"# acrostic\n\n[![Package Version](https://img.shields.io/hexpm/v/acrostic)](https://hex.pm/packages/acrostic)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/acrostic/)\n\nA pure Gleam implementation of Google Protobuf.\n\n\nNote:\n\n1. only support proto3\n2. only support enum, message, repeated\n3. see `game.proto`\n\n\n```sh\ngleam add acrostic\n```\n```gleam\nimport acrostic\n\npub fn main() {\n  acrostic.gen([&quot;game.proto&quot;], to: &quot;src/game.gleam&quot;, flags: acrostic.Flags(False, False))\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/acrostic&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\n```\n","url":"index.html"},{"doc":"acrostic/helper","title":"cmd","content":"pub fn cmd(command: String) -&gt; String\n\nSynonyms:\nacrostic/helper.cmd\nacrostic/helper cmd","url":"acrostic/helper.html#cmd"},{"doc":"acrostic/helper","title":"lsl","content":"pub fn lsl(n: Int, bits: Int) -&gt; Int\n logic shift left\nSynonyms:\nacrostic/helper.lsl\nacrostic/helper lsl","url":"acrostic/helper.html#lsl"},{"doc":"acrostic/helper","title":"lsr","content":"pub fn lsr(n: Int, bits: Int) -&gt; Int\n logic shift right\nSynonyms:\nacrostic/helper.lsr\nacrostic/helper lsr","url":"acrostic/helper.html#lsr"},{"doc":"acrostic/helper","title":"acrostic/helper","content":"","url":"acrostic/helper.html"},{"doc":"acrostic/parser","title":"PbEnum","content":"pub type PbEnum {\n  PbEnum(name: String, fields: List(PbEnumField))\n}\n\nPbEnum(name: String, fields: List(PbEnumField))\n\n\nSynonyms:\nacrostic/parser.PbEnum\nacrostic/parser PbEnum","url":"acrostic/parser.html#PbEnum"},{"doc":"acrostic/parser","title":"PbEnumField","content":"pub type PbEnumField {\n  PbEnumField(name: String, tag: Int)\n}\n\nPbEnumField(name: String, tag: Int)\n\n\nSynonyms:\nacrostic/parser.PbEnumField\nacrostic/parser PbEnumField","url":"acrostic/parser.html#PbEnumField"},{"doc":"acrostic/parser","title":"PbMessage","content":"pub type PbMessage {\n  Message(name: String, fields: List(PbMessageField))\n}\n\nMessage(name: String, fields: List(PbMessageField))\n\n\nSynonyms:\nacrostic/parser.PbMessage\nacrostic/parser PbMessage","url":"acrostic/parser.html#PbMessage"},{"doc":"acrostic/parser","title":"PbMessageField","content":"pub type PbMessageField {\n  Field(repeated: Bool, ty: String, name: String, tag: Int)\n}\n\nField(repeated: Bool, ty: String, name: String, tag: Int)\n\n\nSynonyms:\nacrostic/parser.PbMessageField\nacrostic/parser PbMessageField","url":"acrostic/parser.html#PbMessageField"},{"doc":"acrostic/parser","title":"Token","content":"pub type Token {\n  MessageKeyword\n  EnumKeyword\n  LeftCurly\n  RightCurly\n  Repeated\n  Equals\n  Semicolon\n  Num(Int)\n  Comment(String)\n  PascalIdentifier(String)\n  SnakeIdentifier(String)\n  Identifier(String)\n}\n\nMessageKeyword\n\n\nEnumKeyword\n\n\nLeftCurly\n\n\nRightCurly\n\n\nRepeated\n\n\nEquals\n\n\nSemicolon\n\n\nNum(Int)\n\n\nComment(String)\n\n\nPascalIdentifier(String)\n\n\nSnakeIdentifier(String)\n\n\nIdentifier(String)\n\n\nSynonyms:\nacrostic/parser.Token\nacrostic/parser Token","url":"acrostic/parser.html#Token"},{"doc":"acrostic/parser","title":"parser","content":"pub fn parser() -&gt; #(\n  Lexer(Token, Nil),\n  Parser(PbMessage, Token, a),\n  Parser(PbEnum, Token, a),\n)\n\nSynonyms:\nacrostic/parser.parser\nacrostic/parser parser","url":"acrostic/parser.html#parser"},{"doc":"acrostic/parser","title":"acrostic/parser","content":"","url":"acrostic/parser.html"},{"doc":"acrostic","title":"Flags","content":"pub type Flags {\n  Flags(enum_to_int: Bool, int_to_enum: Bool)\n}\n\nFlags(enum_to_int: Bool, int_to_enum: Bool)\n\n\nSynonyms:\nacrostic.Flags\nacrostic Flags","url":"acrostic.html#Flags"},{"doc":"acrostic","title":"Message","content":"pub type Message {\n  Message(\n    id: Int,\n    name: String,\n    fields: List(parser.PbMessageField),\n  )\n}\n\nMessage(\n  id: Int,\n  name: String,\n  fields: List(parser.PbMessageField),\n)\n\n\nSynonyms:\nacrostic.Message\nacrostic Message","url":"acrostic.html#Message"},{"doc":"acrostic","title":"gen","content":"pub fn gen(\n  protos: List(String),\n  to out_path: String,\n  flags flags: Flags,\n) -&gt; Nil\n\nSynonyms:\nacrostic.gen\nacrostic gen","url":"acrostic.html#gen"},{"doc":"acrostic","title":"acrostic","content":"","url":"acrostic.html"},{"doc":"acrostic/decoding","title":"Key","content":"pub type Key {\n  Key(field_number: Int, wire_type: Int)\n}\n\nKey(field_number: Int, wire_type: Int)\n\n\nSynonyms:\nacrostic/decoding.Key\nacrostic/decoding Key","url":"acrostic/decoding.html#Key"},{"doc":"acrostic/decoding","title":"decode_to_string","content":"pub fn decode_to_string(\n  binary: BitArray,\n) -&gt; Result(String, String)\n\nSynonyms:\nacrostic/decoding.decode_to_string\nacrostic/decoding decode_to_string","url":"acrostic/decoding.html#decode_to_string"},{"doc":"acrostic/decoding","title":"read_bool","content":"pub fn read_bool(binary: BitArray) -&gt; #(Bool, BitArray)\n\nSynonyms:\nacrostic/decoding.read_bool\nacrostic/decoding read_bool","url":"acrostic/decoding.html#read_bool"},{"doc":"acrostic/decoding","title":"read_bytes","content":"pub fn read_bytes(\n  bin: BitArray,\n  length: Int,\n) -&gt; Result(#(BitArray, BitArray), Nil)\n\nSynonyms:\nacrostic/decoding.read_bytes\nacrostic/decoding read_bytes","url":"acrostic/decoding.html#read_bytes"},{"doc":"acrostic/decoding","title":"read_i32","content":"pub fn read_i32(binary: BitArray) -&gt; #(Float, BitArray)\n\nSynonyms:\nacrostic/decoding.read_i32\nacrostic/decoding read_i32","url":"acrostic/decoding.html#read_i32"},{"doc":"acrostic/decoding","title":"read_i64","content":"pub fn read_i64(binary: BitArray) -&gt; #(Float, BitArray)\n\nSynonyms:\nacrostic/decoding.read_i64\nacrostic/decoding read_i64","url":"acrostic/decoding.html#read_i64"},{"doc":"acrostic/decoding","title":"read_key","content":"pub fn read_key(binary: BitArray) -&gt; #(Key, BitArray)\n\nSynonyms:\nacrostic/decoding.read_key\nacrostic/decoding read_key","url":"acrostic/decoding.html#read_key"},{"doc":"acrostic/decoding","title":"read_len_field","content":"pub fn read_len_field(\n  binary: BitArray,\n  decoder: fn(BitArray) -&gt; Result(a, String),\n) -&gt; #(a, BitArray)\n\nSynonyms:\nacrostic/decoding.read_len_field\nacrostic/decoding read_len_field","url":"acrostic/decoding.html#read_len_field"},{"doc":"acrostic/decoding","title":"read_len_packed_field","content":"pub fn read_len_packed_field(\n  binary: BitArray,\n  reader: fn(BitArray) -&gt; #(a, BitArray),\n) -&gt; #(List(a), BitArray)\n\nSynonyms:\nacrostic/decoding.read_len_packed_field\nacrostic/decoding read_len_packed_field","url":"acrostic/decoding.html#read_len_packed_field"},{"doc":"acrostic/decoding","title":"read_string","content":"pub fn read_string(binary: BitArray) -&gt; #(String, BitArray)\n\nSynonyms:\nacrostic/decoding.read_string\nacrostic/decoding read_string","url":"acrostic/decoding.html#read_string"},{"doc":"acrostic/decoding","title":"read_varint","content":"pub fn read_varint(binary: BitArray) -&gt; #(Int, BitArray)\n\nSynonyms:\nacrostic/decoding.read_varint\nacrostic/decoding read_varint","url":"acrostic/decoding.html#read_varint"},{"doc":"acrostic/decoding","title":"acrostic/decoding","content":"","url":"acrostic/decoding.html"},{"doc":"acrostic/encoding","title":"BasicEncoder","content":"pub type BasicEncoder(value) =\n  fn(value) -&gt; BitArray\n\n\nSynonyms:\nacrostic/encoding.BasicEncoder\nacrostic/encoding BasicEncoder","url":"acrostic/encoding.html#BasicEncoder"},{"doc":"acrostic/encoding","title":"FieldEncoder","content":"pub type FieldEncoder(value) {\n  FieldEncoder(wire_type: WireType, encode: BasicEncoder(value))\n}\n\nFieldEncoder(wire_type: WireType, encode: BasicEncoder(value))\n\n\nSynonyms:\nacrostic/encoding.FieldEncoder\nacrostic/encoding FieldEncoder","url":"acrostic/encoding.html#FieldEncoder"},{"doc":"acrostic/encoding","title":"WireType","content":"pub type WireType {\n  WireVarIntTy\n  WireI64Ty\n  WireLenTy\n  WireI32Ty\n}\n\nWireVarIntTy\n\n\nWireI64Ty\n\n\nWireLenTy\n\n\nWireI32Ty\n\n\nSynonyms:\nacrostic/encoding.WireType\nacrostic/encoding WireType","url":"acrostic/encoding.html#WireType"},{"doc":"acrostic/encoding","title":"bool_field_encoder","content":"pub const bool_field_encoder: FieldEncoder(Bool)\n\nSynonyms:\nacrostic/encoding.bool_field_encoder\nacrostic/encoding bool_field_encoder","url":"acrostic/encoding.html#bool_field_encoder"},{"doc":"acrostic/encoding","title":"i32_field_encoder","content":"pub const i32_field_encoder: FieldEncoder(Float)\n\nSynonyms:\nacrostic/encoding.i32_field_encoder\nacrostic/encoding i32_field_encoder","url":"acrostic/encoding.html#i32_field_encoder"},{"doc":"acrostic/encoding","title":"i64_field_encoder","content":"pub const i64_field_encoder: FieldEncoder(Float)\n\nSynonyms:\nacrostic/encoding.i64_field_encoder\nacrostic/encoding i64_field_encoder","url":"acrostic/encoding.html#i64_field_encoder"},{"doc":"acrostic/encoding","title":"int_field_encoder","content":"pub const int_field_encoder: FieldEncoder(Int)\n\nSynonyms:\nacrostic/encoding.int_field_encoder\nacrostic/encoding int_field_encoder","url":"acrostic/encoding.html#int_field_encoder"},{"doc":"acrostic/encoding","title":"string_field_encoder","content":"pub const string_field_encoder: FieldEncoder(String)\n\nSynonyms:\nacrostic/encoding.string_field_encoder\nacrostic/encoding string_field_encoder","url":"acrostic/encoding.html#string_field_encoder"},{"doc":"acrostic/encoding","title":"encode_bool","content":"pub fn encode_bool(b: Bool) -&gt; BitArray\n\nSynonyms:\nacrostic/encoding.encode_bool\nacrostic/encoding encode_bool","url":"acrostic/encoding.html#encode_bool"},{"doc":"acrostic/encoding","title":"encode_field","content":"pub fn encode_field(\n  field_num: Int,\n  value: a,\n  encoder: FieldEncoder(a),\n) -&gt; BitArray\n\nSynonyms:\nacrostic/encoding.encode_field\nacrostic/encoding encode_field","url":"acrostic/encoding.html#encode_field"},{"doc":"acrostic/encoding","title":"encode_i32","content":"pub fn encode_i32(n: Float) -&gt; BitArray\n\nSynonyms:\nacrostic/encoding.encode_i32\nacrostic/encoding encode_i32","url":"acrostic/encoding.html#encode_i32"},{"doc":"acrostic/encoding","title":"encode_i64","content":"pub fn encode_i64(n: Float) -&gt; BitArray\n\nSynonyms:\nacrostic/encoding.encode_i64\nacrostic/encoding encode_i64","url":"acrostic/encoding.html#encode_i64"},{"doc":"acrostic/encoding","title":"encode_repeated_field","content":"pub fn encode_repeated_field(\n  field_num: Int,\n  list: List(a),\n  encoder: FieldEncoder(a),\n) -&gt; BitArray\n\nSynonyms:\nacrostic/encoding.encode_repeated_field\nacrostic/encoding encode_repeated_field","url":"acrostic/encoding.html#encode_repeated_field"},{"doc":"acrostic/encoding","title":"encode_string","content":"pub fn encode_string(s: String) -&gt; BitArray\n\nSynonyms:\nacrostic/encoding.encode_string\nacrostic/encoding encode_string","url":"acrostic/encoding.html#encode_string"},{"doc":"acrostic/encoding","title":"encode_varint","content":"pub fn encode_varint(n: Int) -&gt; BitArray\n\nSynonyms:\nacrostic/encoding.encode_varint\nacrostic/encoding encode_varint","url":"acrostic/encoding.html#encode_varint"},{"doc":"acrostic/encoding","title":"acrostic/encoding","content":"","url":"acrostic/encoding.html"},{"doc":"acrostic/valid","title":"valid_int32","content":"pub fn valid_int32(n: Int, fallback: fn(Int, Int) -&gt; Int) -&gt; Int\n\nSynonyms:\nacrostic/valid.valid_int32\nacrostic/valid valid_int32","url":"acrostic/valid.html#valid_int32"},{"doc":"acrostic/valid","title":"valid_int64","content":"pub fn valid_int64(n: Int, fallback: fn(Int, Int) -&gt; Int) -&gt; Int\n\nSynonyms:\nacrostic/valid.valid_int64\nacrostic/valid valid_int64","url":"acrostic/valid.html#valid_int64"},{"doc":"acrostic/valid","title":"valid_uint32","content":"pub fn valid_uint32(n: Int, fallback: fn(Int, Int) -&gt; Int) -&gt; Int\n\nSynonyms:\nacrostic/valid.valid_uint32\nacrostic/valid valid_uint32","url":"acrostic/valid.html#valid_uint32"},{"doc":"acrostic/valid","title":"valid_uint64","content":"pub fn valid_uint64(n: Int, fallback: fn(Int, Int) -&gt; Int) -&gt; Int\n\nSynonyms:\nacrostic/valid.valid_uint64\nacrostic/valid valid_uint64","url":"acrostic/valid.html#valid_uint64"},{"doc":"acrostic/valid","title":"acrostic/valid","content":"","url":"acrostic/valid.html"}]);